package src;
import java.util.ArrayList;

public final class LongTermMemory {

	private ArrayList<LongCell>[][] LTM;
	private int offset = 0;
	private int delta = 5;
	private int diff = 0;
	
	@SuppressWarnings("unchecked")
	public LongTermMemory(final int i,final int k,final int delta,final int diff){
		this.delta = delta;
		this.diff = diff;
		LTM = new ArrayList[(short)i][(short)k];
	}
	public void put(final int i,final int j,final int k,final int l,final int score,final short[] mblPointer,final char state){
		offset = (k-i)+diff;
		int relK = (short)((delta+1) + offset);
		final LongCell lcell = new LongCell((short)j,(short)l,(short)score,mblPointer,state);
		if(LTM[i][relK] == null){
			LTM[i][relK] = new ArrayList<LongCell>();
		}
		LTM[i][relK].add(lcell);
		//System.out.println("Info: "+i+" "+j+" "+k+" "+l+" "+score+ " Pointer: "+mblPointer);
	}
	public void putLocal(final int i,final int j,final int k,final int l,final int score,final char state){
		//offset = (k-i);
		//int relK = (short)((delta+1) + offset);
		final LongCell lcell = new LongCell((short)j,(short)l,(short)score,state);
		if(LTM[i][k] == null){
			LTM[i][k] = new ArrayList<LongCell>();
		}
		LTM[i][k].add(lcell);
		//System.out.println("Info: "+i+" "+j+" "+k+" "+l+" "+score+ " Pointer: "+mblPointer);
	}
	public ArrayList<LongCell> getList(final int i,final int k){
		offset = (k-i)+diff;
		int relK = (short)((delta+1) + offset);
		return LTM[i][relK];
	}
	public ArrayList<LongCell> getListLocal(final int i,final int k){
		//offset = (k-i);
		//int relK = (short)((delta+1) + offset);
		return LTM[i][k];
	}
	public ArrayList<LongCell> getListReal(final int i,final int k){
		//offset = (k-i);
		//int relK = (short)((delta+1) + offset);
		return LTM[i][k];
	}
}
